// 
// Notice Regarding Standards.  AMD does not provide a license or sublicense to
// any Intellectual Property Rights relating to any standards, including but not
// limited to any audio and/or video codec technologies such as MPEG-2, MPEG-4;
// AVC/H.264; HEVC/H.265; AAC decode/FFMPEG; AAC encode/FFMPEG; VC-1; and MP3
// (collectively, the "Media Technologies"). For clarity, you will pay any
// royalties due for such third party technologies, which may include the Media
// Technologies that are owed as a result of AMD providing the Software to you.
// 
// MIT license 
// 
// Copyright (c) 2016 Advanced Micro Devices, Inc. All rights reserved.
//
// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to deal
// in the Software without restriction, including without limitation the rights
// to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in
// all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
// THE SOFTWARE.
//

#ifndef __glAmdExtLiquidFlash_h_
#define __glAmdExtLiquidFlash_h_
#pragma once

#ifdef __cplusplus
extern "C" {
#endif



#ifndef APIENTRY
#define APIENTRY
#endif
#ifndef APIENTRYP
#define APIENTRYP APIENTRY *
#endif
#ifndef GLAPI
#define GLAPI extern
#endif


typedef struct __GLsync *GLsync;
typedef void* GLFileHandleAMD;


#define GL_FILE_BLOCK_SIZE_AMD            0x91B0
#define GL_FILE_SIZE_AMD                  0x91B1




#ifndef GL_AMD_gpu_file_transfer
#define GL_AMD_gpu_file_transfer 1

typedef void* (GLAPIENTRY * PFNGLCREATEFILEAMDPROC) (GLchar* name, GLenum mode);
typedef void (GLAPIENTRY * PFNGLRELEASEFILEAMDPROC) (GLFileHandleAMD  file);
typedef void (GLAPIENTRY * PFNGLGETFILEPARAMETERI64VAMDPROC) (GLFileHandleAMD  file, GLenum pname, GLuint64* params);
typedef void (GLAPIENTRY * PFNGLREADFILEAMDPROC) (GLuint dstBuffer, GLFileHandleAMD file, GLuint64 bufferOffset, GLuint64 fileOffset, GLuint64 size, GLsync* sync);
typedef void (GLAPIENTRY * PFNGLWRITEFILEAMDPROC) (GLuint srcBuffer, GLFileHandleAMD file, GLuint64 bufferOffset, GLuint64 fileOffset, GLuint64 size, GLsync* sync);

#endif


#ifdef __cplusplus
}
#endif

#endif
